<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for originalDocuments StructType
 * @subpackage Structs
 */
class OriginalDocuments extends AbstractStructBase
{
    /**
     * The altCertificate
     * Meta information extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $altCertificate;
    /**
     * The articlesOfAssociation
     * Meta information extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $articlesOfAssociation;
    /**
     * The certificate
     * Meta information extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $certificate;
    /**
     * The shareholdersMeetingProtocol
     * Meta information extracted from the WSDL
     * - use: optional
     * @var bool
     */
    public $shareholdersMeetingProtocol;
    /**
     * Constructor method for originalDocuments
     * @uses OriginalDocuments::setAltCertificate()
     * @uses OriginalDocuments::setArticlesOfAssociation()
     * @uses OriginalDocuments::setCertificate()
     * @uses OriginalDocuments::setShareholdersMeetingProtocol()
     * @param bool $altCertificate
     * @param bool $articlesOfAssociation
     * @param bool $certificate
     * @param bool $shareholdersMeetingProtocol
     */
    public function __construct($altCertificate = null, $articlesOfAssociation = null, $certificate = null, $shareholdersMeetingProtocol = null)
    {
        $this
            ->setAltCertificate($altCertificate)
            ->setArticlesOfAssociation($articlesOfAssociation)
            ->setCertificate($certificate)
            ->setShareholdersMeetingProtocol($shareholdersMeetingProtocol);
    }
    /**
     * Get altCertificate value
     * @return bool|null
     */
    public function getAltCertificate()
    {
        return $this->altCertificate;
    }
    /**
     * Set altCertificate value
     * @param bool $altCertificate
     * @return \StructType\OriginalDocuments
     */
    public function setAltCertificate($altCertificate = null)
    {
        // validation for constraint: boolean
        if (!is_null($altCertificate) && !is_bool($altCertificate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($altCertificate, true), gettype($altCertificate)), __LINE__);
        }
        $this->altCertificate = $altCertificate;
        return $this;
    }
    /**
     * Get articlesOfAssociation value
     * @return bool|null
     */
    public function getArticlesOfAssociation()
    {
        return $this->articlesOfAssociation;
    }
    /**
     * Set articlesOfAssociation value
     * @param bool $articlesOfAssociation
     * @return \StructType\OriginalDocuments
     */
    public function setArticlesOfAssociation($articlesOfAssociation = null)
    {
        // validation for constraint: boolean
        if (!is_null($articlesOfAssociation) && !is_bool($articlesOfAssociation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($articlesOfAssociation, true), gettype($articlesOfAssociation)), __LINE__);
        }
        $this->articlesOfAssociation = $articlesOfAssociation;
        return $this;
    }
    /**
     * Get certificate value
     * @return bool|null
     */
    public function getCertificate()
    {
        return $this->certificate;
    }
    /**
     * Set certificate value
     * @param bool $certificate
     * @return \StructType\OriginalDocuments
     */
    public function setCertificate($certificate = null)
    {
        // validation for constraint: boolean
        if (!is_null($certificate) && !is_bool($certificate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($certificate, true), gettype($certificate)), __LINE__);
        }
        $this->certificate = $certificate;
        return $this;
    }
    /**
     * Get shareholdersMeetingProtocol value
     * @return bool|null
     */
    public function getShareholdersMeetingProtocol()
    {
        return $this->shareholdersMeetingProtocol;
    }
    /**
     * Set shareholdersMeetingProtocol value
     * @param bool $shareholdersMeetingProtocol
     * @return \StructType\OriginalDocuments
     */
    public function setShareholdersMeetingProtocol($shareholdersMeetingProtocol = null)
    {
        // validation for constraint: boolean
        if (!is_null($shareholdersMeetingProtocol) && !is_bool($shareholdersMeetingProtocol)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($shareholdersMeetingProtocol, true), gettype($shareholdersMeetingProtocol)), __LINE__);
        }
        $this->shareholdersMeetingProtocol = $shareholdersMeetingProtocol;
        return $this;
    }
}
